Overview

SpreadJS includes support for over 180 shapes, including many of the Excel shapes. SpreasJS also provides more advanced functionality using data-driven shapes. For example, you can dynamically generate the shape properties using data from a database or other data source that allows you to create interactive shapes such as for a manufacturing plant floor.

Description
app.js
index.html
styles.css
Copy to CodeMine

SpreadJS provides the following three shape types

  • AutoShape: the autoShape can be used stand-alone.
  • ConnectorShape: the connector shape can be used stand-along or connected to other shape.
  • GroupShape: the group shape is not a real shape but used as a manager to process with a group of shapes easily and quickly.

To use the shape feature, add the JS file link into the document's head section:

<head>
   ...
   <script src='.../spreadjs/gc.spread.sheets.all.x.x.x.min.js' type='text/javascript'></script>
   <script src='.../spreadjs/plugins/gc.spread.sheets.shapes.x.x.x.min.js' type='text/javascript'></script>
</head>

You can manage all shapes in a sheet using the ShapeCollection API:

You can create a autoShape with the sheet.shapes.add method, as shown below:

sheet.shapes.add('autoShape', GC.Spread.Sheets.Shapes.AutoShapeType.heart, 100, 50, 100, 150);

You can create a connectorShape with the sheet.shapes.addConnector method, as shown below:

sheet.shapes.addConnector('connectorShape', GC.Spread.Sheets.Shapes.ConnectorType.elbow, 200, 50, 300, 200);

You can get/remove a shape with name using the following code:

    sheet.shapes.add("shape1", GC.Spread.Sheets.Shapes.AutoShapeType.heart, 100, 50, 100, 150);
    activeSheet.shapes.get("shape1");
    activeSheet.shapes.remove("shape1");
SpreadJS provides the following three shape types AutoShape: the autoShape can be used stand-alone. ConnectorShape: the connector shape can be used stand-along or connected to other shape. GroupShape: the group shape is not a real shape but used as a manager to process with a group of shapes easily and quickly. To use the shape feature, add the JS file link into the document's head section: You can manage all shapes in a sheet using the ShapeCollection API: You can create a autoShape with the sheet.shapes.add method, as shown below: You can create a connectorShape with the sheet.shapes.addConnector method, as shown below: You can get/remove a shape with name using the following code:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); initSpread(spread); initEvent(spread); }; function fillShapeTypeList(type, dom) { var names = []; for (var name in type) { if(name === "none" || (parseInt(name, 10)) == name) { continue; } names.push({name: name, value: type[name]}); } names.sort(function (a, b) { return a.name > b.name ? 1 : -1 }); var html = ""; names.forEach(function (item) { html += '<option value="' + item.value + '">' + item.name + '</option>'; }); dom.innerHTML= html; } function getActiveConnectorShape(sheet) { return sheet.shapes.all().filter(function(sp){ return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.ConnectorShape; }); } function initSpread(spread) { fillShapeTypeList(GC.Spread.Sheets.Shapes.AutoShapeType, _getElementById("autoShapeType")); fillShapeTypeList(GC.Spread.Sheets.Shapes.ConnectorType, _getElementById("connectShapeType")); spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 20, 150, 150); var lineShape = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 290, 20, 420, 170); var lineShapeStyle = lineShape.style(); lineShapeStyle.line.width = 8; lineShape.style(lineShapeStyle); } function initEvent(spread) { _getElementById("insertShape").addEventListener('click', function () { var sheet = spread.getActiveSheet(), shapes = sheet.shapes, total = shapes.all().length; var x = 40 + (total % 2) * 250, y = parseInt(total / 2) * 200 + 20; var shape = shapes.add('', _getElementById("autoShapeType").value, x, y); shape.style().hAlign = 1; }); _getElementById("insertConnectShape").addEventListener('click', function() { var sheet = spread.getActiveSheet(), shapes = sheet.shapes, total = shapes.all().length; var x = 40 + (total % 2) * 250, y = parseInt(total / 2) * 200 + 20; shapes.addConnector('', parseInt(_getElementById("connectShapeType").value), x, y, x + 200, y + 200); }); } function _getElementById(id){ return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> Try selecting a shape from either of the drop-down menus and click the ‘Add’ button to add that shape to the Spread instance. </div> <div class="option-row"> <label for='autoShapeType'>Add Shape: </label> <select id='autoShapeType' class="shapeSelect"></select> <input type='button' id='insertShape' value="Add"/> <label for='connectShapeType'>Add Connect Shape: </label> <select id='connectShapeType' class="shapeSelect"></select> <input type='button' id='insertConnectShape' value="Add"/> </div> </div> </div></body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding-left: 5px; } .divide-line { width: 100%; height: 1px; background: #cbcbcb; margin-top: 10px; margin-bottom: 3px; } .title { text-align: center; font-weight: bold; } label { display: block; margin-top: 15px; margin-bottom: 5px; } p { padding: 2px 10px; background-color: #F4F8EB; } input { width: 160px; margin-left: 10px; display: inline; } input[type=button] { width: 50px; margin-left: 1px; } select { width: 160px; margin-left: 10px; display: inline; } textarea { width: 160px; margin-left: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

SpreadJS provides the following three shape types
AutoShape: the autoShape can be used stand-alone.
ConnectorShape: the connector shape can be used stand-along or connected to other shape.
GroupShape: the group shape is not a real shape but used as a manager to process with a group of shapes easily and quickly.
To use the shape feature, add the JS file link into the document's head section:
You can manage all shapes in a sheet using the ShapeCollection API:
You can create a autoShape with the sheet.shapes.add method, as shown below:
You can create a connectorShape with the sheet.shapes.addConnector method, as shown below:
You can get/remove a shape with name using the following code:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
import Panel from './panel.jsx';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export function AppFunc() {
let spread = null;
let autoGenerateColumns = false;
let insertShape = function(e) {
let sheet = spread.getActiveSheet(),
shapes = sheet.shapes,
total = shapes.all().length;
let x = 40 + (total % 2) * 250,
y = parseInt(total / 2) * 200 + 20;
let shape = shapes.add('', e, x, y);
shape.style().hAlign = 1;
}
let insertConnectShape = function(e) {
let sheet = spread.getActiveSheet(), shapes = sheet.shapes, total = shapes.all().length;
let x = 40 + (total % 2) * 250, y = parseInt(total / 2) * 200 + 20;
shapes.addConnector('', parseInt(e), x, y, x + 200, y + 200);
}
let initSpread = function(value) {
spread = value;
spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 20, 150, 150);
let lineShape = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 290, 20, 420, 170);
let lineShapeStyle = lineShape.style();
lineShapeStyle.line.width = 8;
lineShape.style(lineShapeStyle);
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
insertShape={(addShapeType) => { insertShape(addShapeType) }}
insertConnectShape={(addConnectorShapeType) => { insertConnectShape(addConnectorShapeType) }}>
</Panel>
</div>);
}
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
import Panel from './panel.jsx';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.autoGenerateColumns = false;
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
insertShape={(addShapeType) => { this.insertShape(addShapeType) }}
insertConnectShape={(addConnectorShapeType) => { this.insertConnectShape(addConnectorShapeType) }}>
</Panel>
</div>);
}
insertShape(addShapeType) {
let sheet = this.spread.getActiveSheet(),
shapes = sheet.shapes,
total = shapes.all().length;
let x = 40 + (total % 2) * 250,
y = parseInt(total / 2) * 200 + 20;
let shape = shapes.add('', addShapeType, x, y);
shape.style().hAlign = 1;
}
insertConnectShape(addConnectorShapeType) {
let sheet = this.spread.getActiveSheet(), shapes = sheet.shapes, total = shapes.all().length;
let x = 40 + (total % 2) * 250, y = parseInt(total / 2) * 200 + 20;
shapes.addConnector('', parseInt(addConnectorShapeType), x, y, x + 200, y + 200);
}
initSpread(spread) {
this.spread = spread;
spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 20, 150, 150);
let lineShape = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 290, 20, 420, 170);
let lineShapeStyle = lineShape.style();
lineShapeStyle.line.width = 8;
lineShape.style(lineShapeStyle);
}
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
export default function Panel(props) {
const [shapeOption, setShapeOption] = React.useState({
addShapeType: GC.Spread.Sheets.Shapes.AutoShapeType.actionButtonBackorPrevious,
addConnectorShapeType: GC.Spread.Sheets.Shapes.ConnectorType.elbow,
autoShapeTypeList: getEnumList(GC.Spread.Sheets.Shapes.AutoShapeType),
connectorTypeList: getEnumList(GC.Spread.Sheets.Shapes.ConnectorType)
});
const {
insertShape,
insertConnectShape
} = props;
return (<div class="options-container">
<div class="option-row">
Try selecting a shape from either of the drop-down menus and click the ‘Add’ button to add that shape to the Spread instance.
</div>
<div class="option-row">
<label for='autoShapeType'>Add Shape: </label>
<select class="shapeSelect" value={shapeOption.addShapeType} onChange={(event) => { setShapeOption({ ...shapeOption, addShapeType: event.target.value }); }}>
{shapeOption.autoShapeTypeList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select>
<input type='button' onClick={() => { insertShape(shapeOption.addShapeType) }} value="Add" />
<label for='connectShapeType'>Add Connect Shape: </label>
<select class="shapeSelect" value={shapeOption.addConnectorShapeType} onChange={(event) => { setShapeOption({ ...shapeOption, addConnectorShapeType: event.target.value }); }}>
{shapeOption.connectorTypeList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select>
<input type='button' onClick={() => { insertConnectShape(shapeOption.addConnectorShapeType) }} value="Add" />
</div>
</div >);
}
function getEnumList(enumObject) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app{
width: 100%;
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

SpreadJS provides the following three shape types
AutoShape: the autoShape can be used stand-alone.
ConnectorShape: the connector shape can be used stand-along or connected to other shape.
GroupShape: the group shape is not a real shape but used as a manager to process with a group of shapes easily and quickly.
To use the shape feature, add the JS file link into the document's head section:
You can manage all shapes in a sheet using the ShapeCollection API:
You can create a autoShape with the sheet.shapes.add method, as shown below:
You can create a connectorShape with the sheet.shapes.addConnector method, as shown below:
You can get/remove a shape with name using the following code:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import './styles.css';
function getEnumList(enumObject: object) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(<any>name, 10)) == <any>name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function(a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
addShapeType = GC.Spread.Sheets.Shapes.AutoShapeType.actionButtonBackorPrevious;
addConnectorShapeType = GC.Spread.Sheets.Shapes.ConnectorType.elbow;
autoShapeTypeList = getEnumList(GC.Spread.Sheets.Shapes.AutoShapeType);
connectorTypeList = getEnumList(GC.Spread.Sheets.Shapes.ConnectorType);
initSpread($event: any) {
let spread = this.spread = $event.spread;
spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 20, 150, 150);
let lineShape = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 290, 20, 420, 170);
let lineShapeStyle = lineShape.style();
lineShapeStyle.line.width = 8;
lineShape.style(lineShapeStyle);
}
insertShape(addShapeType: GC.Spread.Sheets.Shapes.AutoShapeType) {
let sheet = this.spread.getActiveSheet(),
shapes = sheet.shapes,
total = shapes.all().length;
let x = 40 + (total % 2) * 250,
y = parseInt(total / 2 + '') * 200 + 20;
let shape = shapes.add('', addShapeType, x, y);
shape.style().hAlign = 1;
}
insertConnectShape(addConnectorShapeType: GC.Spread.Sheets.Shapes.ConnectorType) {
// addConnectorShapeType = parseInt(addConnectorShapeType, 10);
let sheet = this.spread.getActiveSheet(), shapes = sheet.shapes, total = shapes.all().length;
let x = 40 + (total % 2) * 250, y = parseInt(total / 2 + '') * 200 + 20;
shapes.addConnector('', parseInt(addConnectorShapeType), x, y, x + 200, y + 200);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Try selecting a shape from either of the drop-down menus and click the ‘Add’ button to add that shape to the Spread instance.
</div>
<div class="option-row">
<label for='autoShapeType'>Add Shape: </label>
<select class="shapeSelect" [value]="addShapeType|number" [(ngModel)]="addShapeType">
<option *ngFor="let item of autoShapeTypeList" [value]="item.value">
{{item.name}}
</option>
</select>
<input type='button' (click)="insertShape(addShapeType)" value="Add" />
<label for='connectShapeType'>Add Connect Shape: </label>
<select class="shapeSelect" [value]="addConnectorShapeType|number" [(ngModel)]="addConnectorShapeType">
<option *ngFor="let item of connectorTypeList" [value]="item.value">
{{item.name}}
</option>
</select>
<input type='button' (click)='insertConnectShape(addConnectorShapeType)' value="Add" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.0-master-2026-08-10-0936/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

SpreadJS provides the following three shape types
AutoShape: the autoShape can be used stand-alone.
ConnectorShape: the connector shape can be used stand-along or connected to other shape.
GroupShape: the group shape is not a real shape but used as a manager to process with a group of shapes easily and quickly.
To use the shape feature, add the JS file link into the document's head section:
You can manage all shapes in a sheet using the ShapeCollection API:
You can create a autoShape with the sheet.shapes.add method, as shown below:
You can create a connectorShape with the sheet.shapes.addConnector method, as shown below:
You can get/remove a shape with name using the following code:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<shape-panel @insertShape="insertShape" @insertConnectShape="insertConnectShape">
</shape-panel>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref, createApp } from "vue";
import "@mescius/spread-sheets-vue";
import '@mescius/spread-sheets-shapes';
const spreadRef = ref(null);
const initSpread = (spread) => {
spreadRef.value = spread;
spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 20, 150, 150);
let lineShape = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 290, 20, 420, 170);
let lineShapeStyle = lineShape.style();
lineShapeStyle.line.width = 8;
lineShape.style(lineShapeStyle);
}
const insertShape = (addShapeType) => {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet(),
shapes = sheet.shapes,
total = shapes.all().length;
let x = 40 + (total % 2) * 250,
y = parseInt(total / 2) * 200 + 20;
let shape = shapes.add('', addShapeType, x, y);
shape.style().hAlign = 1;
}
const insertConnectShape = (addConnectoShapeType) => {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet(),
shapes = sheet.shapes,
total = shapes.all().length;
let x = 40 + (total % 2) * 250,
y = parseInt(total / 2) * 200 + 20;
shapes.addConnector('', addConnectoShapeType, x, y, x + 200, y + 200);
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<template>
<div class="options-container">
<div class="option-row">
Try selecting a shape from either of the drop-down menus and click the ‘Add’ button to add that shape to the Spread instance.
</div>
<div class="option-row">
<label for='autoShapeType'>Add Shape:</label>
<select class="shapeSelect" id="'autoShapeType'" v-model.number="addShapeType">
<option :value="item.value" v-for="item in autoShapeTypeList" :key="item.name">{{ item.name }}
</option>
</select>
<input type='button' @click="insertShape" value="Add" />
<label for='connectShapeType'>Add Connect Shape: </label>
<select class="shapeSelect" id="connectShapeType" v-model.number="addConnectorShapeType">
<option :value="item.value" v-for="item in connectorTypeList" :key="item.name">{{ item.name }}
</option>
</select>
<input type='button' @click='insertConnectShape' value="Add" />
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import { defineEmits, ref } from 'vue';
function getEnumList(enumObject) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
const emits = defineEmits(['insertShape', 'insertConnectShape']);
const props = [
"showBorderPanel",
"showShapeFillPropPanel",
"showShapeTxtPanel",
"showConnectorPropPanel"
];
const addShapeType = ref(GC.Spread.Sheets.Shapes.AutoShapeType.actionButtonBackorPrevious);
const addConnectorShapeType = ref(GC.Spread.Sheets.Shapes.ConnectorType.elbow);
const autoShapeTypeList = ref(getEnumList(GC.Spread.Sheets.Shapes.AutoShapeType));
const connectorTypeList = ref(getEnumList(GC.Spread.Sheets.Shapes.ConnectorType));
const insertShape = () => {
emits('insertShape', addShapeType.value);
};
const insertConnectShape = () => {
emits('insertConnectShape', addConnectorShapeType.value);
};
</script>
<style scoped>
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/inventory-tracker.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);